import { componentQrl, inlinedQrl, useStore, useSignal, useVisibleTaskQrl, useLexicalScope, _jsxQ, _fnSignal, _jsxC, Slot } from "@builder.io/qwik";
const Slider = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const state = useStore({
    isDown: false,
    startX: 0,
    scrollLeft: 0,
    isMouseOver: false
  });
  const slider = useSignal();
  const onMouseDown = /* @__PURE__ */ inlinedQrl((e) => {
    const [slider2, state2] = useLexicalScope();
    state2.isDown = true;
    state2.startX = e.pageX - slider2.value.offsetLeft;
    state2.scrollLeft = slider2.value.scrollLeft;
  }, "Slider_component_onMouseDown_WN9guyVeHSM", [
    slider,
    state
  ]);
  const exit = /* @__PURE__ */ inlinedQrl(() => {
    const [state2] = useLexicalScope();
    state2.isDown = false;
    state2.isMouseOver = false;
  }, "Slider_component_exit_OOpUKBP0tL4", [
    state
  ]);
  const onMouseMove = /* @__PURE__ */ inlinedQrl((e) => {
    const [props2, slider2, state2] = useLexicalScope();
    if (!state2.isDown)
      return;
    const x = e.pageX - slider2.value.offsetLeft;
    const walk = (x - state2.startX) * (props2.scrollSpeed ?? 1);
    slider2.value.scrollLeft = state2.scrollLeft - walk;
  }, "Slider_component_onMouseMove_sqOFV6JnIxY", [
    props,
    slider,
    state
  ]);
  const handleMouseEnter = /* @__PURE__ */ inlinedQrl(() => {
    const [state2] = useLexicalScope();
    state2.isMouseOver = true;
  }, "Slider_component_handleMouseEnter_nED0ZS0dwY4", [
    state
  ]);
  useVisibleTaskQrl(/* @__PURE__ */ inlinedQrl(({ cleanup }) => {
    const [props2, slider2, state2] = useLexicalScope();
    if ((props2.autoScroll ?? false) && !state2.isMouseOver) {
      const sliderElement = slider2.value;
      if (sliderElement) {
        const maxScrollLeft = sliderElement.scrollWidth - sliderElement.clientWidth;
        let scrollDirection = 1;
        const interval = setInterval(() => {
          if (!state2.isMouseOver) {
            if (scrollDirection === 1) {
              if (sliderElement.scrollLeft >= maxScrollLeft)
                scrollDirection = -1;
            } else if (sliderElement.scrollLeft <= 0)
              scrollDirection = 1;
            if (scrollDirection === 1)
              sliderElement.scrollLeft += 1;
            else
              sliderElement.scrollLeft -= 1;
          }
        }, props2.autoScrollSpeed ?? 15);
        cleanup(() => clearInterval(interval));
      }
    }
  }, "Slider_component_useVisibleTask_FVuPkVHsyn8", [
    props,
    slider,
    state
  ]));
  return /* @__PURE__ */ _jsxQ("div", {
    ref: slider
  }, {
    class: _fnSignal((p0) => `${p0.styleClass ?? ""}`, [
      props
    ], '`${p0.styleClass??""}`'),
    onMouseDown$: onMouseDown,
    onMouseEnter$: handleMouseEnter,
    onMouseLeave$: exit,
    onMouseMove$: onMouseMove,
    onMouseUp$: exit,
    "preventdefault:mousedown": true,
    style: _fnSignal((p0) => ({
      overflowX: `${p0.showScrollbar ?? true ? "scroll" : "hidden"}`,
      display: "flex",
      gap: `${p0.gap ?? 15}px`,
      width: p0.width ?? ""
    }), [
      props
    ], '{overflowX:`${p0.showScrollbar??true?"scroll":"hidden"}`,display:"flex",gap:`${p0.gap??15}px`,width:p0.width??""}')
  }, /* @__PURE__ */ _jsxC(Slot, null, 3, "eq_0"), 1, "eq_1");
}, "Slider_component_wrpW1Kq03pA"));
export {
  Slider
};
